require(glmnet)
# Set random seed to make the result reproducible
set.seed(2)

# Load the data from file
data <- read.csv('data.txt', header=TRUE)
cols = length(data)
x<-as.matrix(data)[,seq(cols-1)]
y<-as.matrix(data)[,cols]

# Split data to train and test sets
train_size <- floor(0.8 * nrow(data)) # Use 80% of the data for training
train <- sample(seq_len(nrow(data)), size = train_size) # Generate indices for training data
test <- (-train)

# Tested lambda values
lambda_grid <- 10^ seq(10 , -3 , length =200)

# Fit LS
ls.train_model <- lm(Y ~ ., data=data[train,])
ls.prediction <- predict(ls.train_model, data[test,])

# Fit LASSO 
lasso.model <- glmnet(x[train,],y[train],alpha=1, lambda=lambda_grid, standardize=TRUE)
lasso.cv.out <- cv.glmnet(x[train,],y[train],alpha=1)
#plot(lasso.cv.out)
lasso.lambda <- lasso.cv.out$lambda.min
lasso.prediction <- predict(lasso.model, s=lasso.lambda, newx=x[test,])
lasso.coefficients <- predict(lasso.model, type="coefficients", s=lasso.lambda)
# TASK 1:
# There is a methodological error in the above block of code. Find it and correct it.
# Hint: The error causes the variable lasso.coefficients contain values of
# lesser precision than what we could get from the data.

# Display the coefficients and selected variables
print("LASSO coefficients:")
print(as.matrix(lasso.coefficients))
print(as.matrix(lasso.coefficients)[seq(2,cols),] != 0)

# TASK 2: Implement analogous fitting method for Ridge regression.  Compute the Mean
# Squared Error for Ridge regression, LS and LASSO and compare them.

# TASK 3: We have used the value lambda.min from the output of cv.glmnet.  The
# output also contains value lambda.1se.  The documentation defines lambda.1se as
# "The largest value of lambda such that error is within 1 standard error of the
# minimum." It is a recommended heuristic alternative to lambda.min.
#
# a) Explain in what probability distribution this value is the standard deviation
# and how this distribution arises here. b) Explain would we gain and what would we
# lose by using lambda.1se instead of lambda.min.

# TASK 4: Assume we want LASSO to select exactly 2 variables while still minimizing
# MSE.  What is then the desired parameter lambda (with 1e-1 precission)? What are
# the variables? What is the MSE?  Implement an algorithm to determine that. 
# Check if the selected variables are the same as the ones exhaustive subset search
# would select.  You may use the `regsubsets` function from the `leaps` library to
# do this or implement the search yourself for subsets of size 2.
